#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE

short _ti89, _ti92plus;

#include <tigcclib.h>

void _main(void)
{
	char *input_string, *output_string = NULL;
	short i; /*a counter for the loop*/
	ESI argptr;
	
	InitArgPtr(argptr); /*sets up argptr to point to the first argument of the program*/
	
	if(GetArgType(argptr) == STR_TAG) /*if the first argument is a string*/
	{
		input_string = GetStrnArg(argptr); /*get the argument*/
		output_string = malloc(strlen(input_string) + 2); /*allocate memory for the output
		buffer*/
		if(output_string == NULL) /*if there was not enough memory*/
		{
			while(GetArgType(top_estack) != END_TAG) /*cleans the arguments of the program
			off the stack*/
			{
				top_estack = next_expression_index(top_estack);
			}
			top_estack--;

			push_expr_quantum($(Memory low), STR_TAG); /*push_ANSI_string only returns one
			word.  Thanks to KronicDeth for telling me how to do this*/
			return;
		}
		for(i = 0; i < (short)strlen(input_string); i++) /*loop through the input string*/
		{
			if((input_string[i] >= 65 && input_string[i] <= 90) || (input_string[i] >= 97
			&& input_string[i] <= 122)) /*if the current character is a letter*/
			{
				input_string[i] = ((input_string[i] - (input_string[i] <= 90 ? 52 : 84)) %
				26) + (input_string[i] <= 90 ? 65 : 97); /*rotate the letter 13 places*/
			}
		}
		
		while(GetArgType(top_estack) != END_TAG) /*cleans the arguments of the program
		off the stack*/
		{
			top_estack = next_expression_index(top_estack);
		}
		top_estack--;
		
		output_string[0] = 0; /*puts a null char at the beginning of the output string*/
		memcpy(output_string + 1, input_string, strlen(input_string) + 1); /*copies the
		input string, including the null character, to the output string*/
		push_expr_quantum(output_string + strlen(output_string + 1) + 1, STR_TAG);
		/*returns the output string*/
	}
	else /*no arguments or the first argument was not a string*/
	{
		while(GetArgType(top_estack) != END_TAG) /*cleans the arguments of the program
		off the stack*/
		{
			top_estack = next_expression_index(top_estack);
		}
		top_estack--;

		push_expr_quantum($(Argument must be a string), STR_TAG);
	}
	if(output_string != NULL) /*free the memory for the output string*/
	{
		free(output_string);
	}
}
